;(C)by Unreal Software 2003-2005
;www.unrealsoftware.de

;-----------------------Einstellungen Laden
AppTitle "Unreal Software's Silvester 2003"
stream=ReadFile("settings.txt")
ReadLine(stream)
ReadLine(stream)
Global op_scrx=ReadLine(stream)
ReadLine(stream)
Global op_scry=ReadLine(stream)
ReadLine(stream)
op_scrdepth=ReadLine(stream)
ReadLine(stream)
op_scrmode=ReadLine(stream)
ReadLine(stream)
op_partikel=ReadLine(stream)
ReadLine(stream)
op_brigthness=ReadLine(stream)
ReadLine(stream)
op_plants=ReadLine(stream)
ReadLine(stream)
op_high=ReadLine(stream)
CloseFile(stream)

;-----------------------Initialisieren
Graphics3D op_scrx,op_scry,op_scrdepth,op_scrmode
SeedRnd MilliSecs()
SetBuffer BackBuffer()

Global ms
Global fire

font=LoadFont("Arial",20,1)
SetFont font
Color 255,150,0

Global cam=CreateCamera()
PositionEntity cam,1000,0,1000

AmbientLight op_brigthness,op_brigthness,op_brigthness

;MODELS
TextureFilter "",4:Global m_bush1=LoadMesh("models/bush1.b3d"):MoveEntity m_bush1,-5000,-5000,-5000:HideEntity m_bush1
TextureFilter "",4:Global m_bush2=LoadMesh("models/bush2.b3d"):MoveEntity m_bush2,-5000,-5000,-5000:HideEntity m_bush2
TextureFilter "",4:Global m_tree1=LoadMesh("models/tree1.b3d"):MoveEntity m_tree1,-5000,-5000,-5000:HideEntity m_tree1
ClearTextureFilters 
Global m_rocket=LoadMesh("models/rocket.b3d"):MoveEntity m_rocket,-5000,-5000,-5000:HideEntity m_rocket
Global m_boom=LoadMesh("models/boom.b3d"):MoveEntity m_boom,-5000,-5000,-5000:HideEntity m_boom
Global m_sparkl=LoadMesh("models/sparkl.b3d"):MoveEntity m_sparkl,-5000,-5000,-5000:HideEntity m_sparkl
Global m_biene=LoadMesh("models/biene.b3d"):MoveEntity m_biene,-5000,-5000,-5000:HideEntity m_biene

;GFX
tex=LoadTexture("gfx/gras.png",8):ScaleTexture tex,8,8
Dim flare(2)
For i=0 To 2
	flare(i)=LoadTexture("gfx/flare"+i+".bmp",2)
Next
gfx_fire=LoadAnimImage("gfx/fire.bmp",64,64,0,2)
gfx_object=LoadAnimImage("gfx/object.bmp",64,64,0,4)
gfx_ch=LoadImage("gfx/ch.bmp"):MidHandle gfx_ch

;SFX
Dim sfx_explode(4)
For i=0 To 4
	sfx_explode(i)=LoadSound("sfx/explode"+i+".wav")
Next
Dim sfx_wegflieg(6)
For i=0 To 6
	sfx_wegflieg(i)=Load3DSound("sfx/wegflieg"+i+".wav")
Next


;Terrain
Global terrain=LoadTerrain("gfx/terrain.png")
EntityTexture terrain,tex
ScaleEntity terrain,7,200,7
TerrainShading terrain,1

;Plane
plane=CreatePlane()
EntityTexture plane,tex
ScaleEntity plane,7,1,7
PositionEntity plane,0,0.01,0

;Light
firelight=CreateLight(2,cam)
LightColor firelight,255,200,0
LightRange firelight,6
HideEntity firelight

;Objekt Type
Type obj
	Field typ
	Field h
End Type

;Active Objekt Type
Type aobj
	Field typ
	Field h
	Field mode
	Field timer
	Field started
End Type

;Funken
Type spark
	Field ph
	Field h
	Field alpha#
	Field speed#
End Type

;Smoke
Type smoke
	Field h
	Field alpha#
End Type

;Setfunction
Function set(typ,x#,z#)
	obj.obj=New obj
	obj\typ=typ
	Select typ
		Case 0
			h=CopyMesh(m_bush1)
			EntityFX h,16
			EntityAutoFade h,800,900
			sf#=Rnd(0.6,1.0)
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0,z#
			obj\h=h
		Case 1
			h=CopyMesh(m_bush2)
			EntityFX h,16
			EntityAutoFade h,800,900
			sf#=Rnd(0.6,1.0)
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0,z#
			obj\h=h
		Case 2
			h=CopyMesh(m_tree1)
			EntityFX h,16
			EntityAutoFade h,800,900
			sf#=Rnd(0.7,1.5)
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0,z#
			obj\h=h
	End Select
End Function

;Set Active Object
Function seta(typ,x#,z#,mode=0,ltimer=0)
	aobj.aobj=New aobj
	aobj\typ=typ
	aobj\mode=mode
	If ltimer Then aobj\timer=ms
	If fire=1 Then
		aobj\started=1
		aobj\timer=ms
	EndIf
	Select typ
		Case 0
			h=CopyMesh(m_rocket)
			EntityFX h,16
			sf#=0.1
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0,z#
			EntityPickMode h,2,1
			aobj\h=h
		Case 1
			h=CopyMesh(m_boom)
			EntityFX h,16
			sf#=0.2
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0.3,z#
			EntityPickMode h,2,1
			RotateEntity h,0,Rand(-180,180),0
			aobj\h=h
		Case 2
			h=CopyMesh(m_sparkl)
			EntityFX h,16
			sf#=0.2
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+0,z#
			EntityPickMode h,2,1
			aobj\h=h
		Case 3
			h=CopyMesh(m_biene)
			EntityFX h,16
			sf#=1
			ScaleEntity h,sf#,sf#,sf#
			PositionEntity h,x#,TerrainY(terrain,x#,0,z#)+1,z#
			aobj\h=h
			RotateEntity h,0,EntityYaw(cam),0
	End Select
	EntityRadius h,5
	EntityPickMode h,1,1
	;<<< DEBUG: Radius >>>
	If debug Then
		s=CreateSphere(5)
		ScaleEntity s,5,5,5
		EntityAlpha s,0.3
		EntityBlend s,3
		PositionEntity s,EntityX(h),EntityY(h),EntityZ(h)
		EntityParent s,h
	EndIf
End Function

;Set Smoke
Function setsmoke(x#,y#,z#,scale#,alpha#)
	smoke.smoke=New smoke
	smoke\h=CreateSprite()
	EntityTexture smoke\h,flare(0)
	ScaleSprite smoke\h,scale#,scale#
	EntityAlpha smoke\h,alpha#
	PositionEntity smoke\h,x#,y#,z#
	EntityColor smoke\h,100,100,100
	smoke\alpha#=alpha#
End Function

;Set Spark
Function setspark(x#,y#,z#,r,g,b,speed#,scale#)
	spark.spark=New spark
	spark\ph=CreatePivot()
	RotateEntity spark\ph,Rand(-180,180),Rand(-180,180),Rand(-180,180)
	spark\h=CreateSprite()
	EntityTexture spark\h,flare(Rand(0,2))
	ScaleSprite spark\h,scale#,scale#
	EntityAlpha spark\h,1
	EntityColor spark\h,r,g,b
	EntityBlend spark\h,3
	PositionEntity spark\ph,x#,y#,z#
	PositionEntity spark\h,x#,y#,z#
	EntityParent spark\h,spark\ph
	spark\alpha#=1
	spark\speed#=speed#
End Function

;Set on
Function seton()
	Local picked
	CameraPick(cam,op_scrx/2,op_scry/2)
	picked=PickedEntity()
	If picked=0 Then Return 0
	For aobj.aobj=Each aobj
		If aobj\h=picked Then		
			aobj\timer=ms
			aobj\started=1
			Return 1		
		EndIf
	Next
	Return 0
End Function



;Landschaft vorbereiten
For i=0 To op_plants
	set(Rand(0,2),Rand(10,2000),Rand(10,2000))
Next



;-----------------------Gameschleife
While Not KeyDown(1)
	
	;Cachen
	ms=MilliSecs()
	mxs#=-MouseXSpeed()
	mys#=MouseYSpeed()
	
	
	;Auf Terrainhhe
	PositionEntity cam, EntityX(cam),TerrainY(terrain,EntityX(cam),0,EntityZ(cam))+15,EntityZ(cam)
	
	;Drehen
	If mxs#<>0 Then RotateEntity cam,EntityPitch(cam),EntityYaw(cam)+mxs#,EntityRoll(cam)
	If mys#<>0 Then
		If mys#>0 Then
			If EntityPitch(cam)+mys#>70
				mys#=70-EntityPitch(cam)
			EndIf
			RotateEntity cam,EntityPitch(cam)+mys#,EntityYaw(cam),EntityRoll(cam)
		ElseIf mys#<0 Then
			If EntityPitch(cam)+mys#<-70
				mys#=-70-EntityPitch(cam)
			EndIf
			RotateEntity cam,EntityPitch(cam)+mys#,EntityYaw(cam),EntityRoll(cam)
		EndIf
	EndIf
	
	;Bewegen
	If KeyDown(31) Then MoveEntity cam,0,0,-1.0*fpsfak#		;Rckwrts
	If KeyDown(17) Then MoveEntity cam,0,0,1.0*fpsfak#		;Vorwrts
	If KeyDown(30) Then MoveEntity cam,-1.0*fpsfak#,0,0		;Links
	If KeyDown(32) Then MoveEntity cam,1.0*fpsfak#,0,0		;Rechts
	
	;Maus
	If MouseHit(1) Then
		;Links: Setzen
		seta(selo,EntityX(cam),EntityZ(cam),fwcol,1)
	EndIf
	If MouseHit(2) Then
		DebugLog "call seton"
		;Rechts: Anznden
		seton()
	EndIf
	
	;Objekt per Mausrad whlen
	msz=MouseZSpeed()
	If msz<>0 Then
		If msz>0 Then
			selo=selo+1
			If selo>3 Then selo=0
		Else
			selo=selo-1
			If selo<0 Then selo=3
		EndIf
	EndIf
	
	;Objekt per E whlen
	If KeyHit(18) Then
		selo=selo+1
		If selo>3 Then selo=0
	EndIf
		
	;Debug an/aus
	If KeyHit(88) Then debug=1-debug
	
	;Hilfe an/aus
	If KeyHit(59) Then help=1-help
	
	;Fire
	If KeyHit(33) Then
		fire=1-fire
	EndIf
	If fire Then
		ShowEntity firelight
		LightColor firelight,255,Rand(170,255),0
		LightRange firelight,Rnd(10,15)
	Else
		HideEntity firelight
	EndIf
	
	;Farbe
	If KeyHit(2) Then fwcol=0
	If KeyHit(3) Then fwcol=1
	If KeyHit(4) Then fwcol=2
	If KeyHit(5) Then fwcol=3
	If KeyHit(6) Then fwcol=4
	If KeyHit(7) Then fwcol=5
	If KeyHit(8) Then fwcol=Rand(0,5)
	
	;Zufllig
	If KeyHit(19) Then
		For i=1 To 3
			seta(0,Rand(0,2000),Rand(0,2000),Rand(0,5),1)
		Next
	EndIf
	
	;Alles anznden
	If KeyHit(57) Then
		For aobj.aobj=Each aobj
			If aobj\started=0 Then
				aobj\started=1
				aobj\timer=ms
			EndIf
		Next
	EndIf
	
	
	;Aktive Objects
	For aobj.aobj=Each aobj
		;If aobj\timer>0 Then
			If aobj\started=1 Then
				Select aobj\typ
					;Rakete
					Case 0
						If Rand(10)=1 Then
							setspark(EntityX(aobj\h),EntityY(aobj\h)+3,EntityZ(aobj\h),255,Rand(100,255),0,0.5,0.3)
						EndIf
						If ms-aobj\timer>5000 Then
							If aobj\started=0 Then
								aobj\started=1
								chan=PlaySound(sfx_wegflieg(Rand(0,6)))
								ChannelPan(chan,Rnd(-1,1))
								ChannelVolume chan,Rnd(0.1,1.0)
							EndIf
							TranslateEntity aobj\h,0,3*fpsfak#,0
							setsmoke(EntityX(aobj\h),EntityY(aobj\h),EntityZ(aobj\h),Rnd(1,2),Rnd(0.1,1))
							If EntityY(aobj\h)>op_high Then
								Select aobj\mode
									Case 0 r=255:g=0:b=0
									Case 1 r=0:g=255:b=0
									Case 2 r=0:g=0:b=255
									Case 3 r=255:g=255:b=0
									Case 4 r=0:g=255:b=255
									Case 5 r=255:g=0:b=255
								End Select
								For i=1 To op_partikel
									setspark(EntityX(aobj\h),EntityY(aobj\h)+3,EntityZ(aobj\h),r,g,b,Rand(1,3),Rnd(1.0,3.6))
								Next
								chan=PlaySound(sfx_explode(Rand(0,4)))
								ChannelPan(chan,Rnd(-1,1))
								ChannelVolume chan,Rnd(0.1,0.3)
								FreeEntity aobj\h
								Delete aobj
							EndIf
						EndIf
					;Bller
					Case 1
						If Rand(10)=1 Then
							setspark(EntityX(aobj\h),EntityY(aobj\h),EntityZ(aobj\h),255,Rand(100,255),0,0.5,0.3)
						EndIf
						If ms-aobj\timer>5000 Then
							Select aobj\mode
								Case 0 r=255:g=0:b=0
								Case 1 r=0:g=255:b=0
								Case 2 r=0:g=0:b=255
								Case 3 r=255:g=255:b=0
								Case 4 r=0:g=255:b=255
								Case 5 r=255:g=0:b=255
							End Select
							For i=1 To op_partikel
								setspark(EntityX(aobj\h),EntityY(aobj\h)+3,EntityZ(aobj\h),r,g,b,Rand(1,3),Rnd(0.5,1.5))
								If Rand(3)=1 Then setsmoke(EntityX(aobj\h)+Rnd(-3,3),EntityY(aobj\h)+Rnd(-3,3),EntityZ(aobj\h)+Rnd(-3,3),Rnd(1,2),Rnd(0.1,1))
							Next
							chan=PlaySound(sfx_explode(Rand(0,4)))
							ChannelPan(chan,Rnd(-1,1))
							ChannelVolume chan,Rnd(0.8,1)
							FreeEntity aobj\h
							Delete aobj
						EndIf
					;Sprhdingens
					Case 2
						Select aobj\mode
							Case 0 r=255:g=0:b=0
							Case 1 r=0:g=255:b=0
							Case 2 r=0:g=0:b=255
							Case 3 r=255:g=255:b=0
							Case 4 r=0:g=255:b=255
							Case 5 r=255:g=0:b=255
						End Select
						setspark(EntityX(aobj\h),EntityY(aobj\h)+6,EntityZ(aobj\h),r,g,b,Rnd(0.2,0.7),Rnd(0.3,0.8))
						If Rand(20)=1 Then setsmoke(EntityX(aobj\h),EntityY(aobj\h),EntityZ(aobj\h),Rnd(1,2),Rnd(0.1,1))
						TranslateEntity aobj\h,0,-0.008*fpsfak#,0
						If EntityY(aobj\h)+6<TerrainY(terrain,EntityX(aobj\h),0,EntityZ(aobj\h)) Then
							FreeEntity aobj\h
							Delete aobj
						EndIf
					;Biene
					Case 3
						Select aobj\mode
							Case 0 r=255:g=0:b=0
							Case 1 r=0:g=255:b=0
							Case 2 r=0:g=0:b=255
							Case 3 r=255:g=255:b=0
							Case 4 r=0:g=255:b=255
							Case 5 r=255:g=0:b=255
						End Select
						setspark(EntityX(aobj\h),EntityY(aobj\h),EntityZ(aobj\h),r,g,b,Rnd(0.1,0.3),Rnd(0.2,0.4))
						MoveEntity aobj\h,0,0,5.0*fpsfak#
						If Rand(20) Then
							TurnEntity aobj\h,0,EntityYaw(aobj\h)+Rand(10,30),0
						ElseIf Rand(18) Then
							TurnEntity aobj\h,0,EntityYaw(aobj\h)+Rand(-30,-10),0
						EndIf
						If Rand(20)=1 Then setsmoke(EntityX(aobj\h),EntityY(aobj\h),EntityZ(aobj\h),Rnd(1,2),Rnd(0.1,1))
						PositionEntity aobj\h,EntityX(aobj\h),TerrainY(terrain,EntityX(aobj\h),0,EntityZ(aobj\h))+Rand(1,3),EntityZ(aobj\h)
						If ms-aobj\timer>10000 Then
							FreeEntity aobj\h
							Delete aobj
						EndIf
				End Select
			EndIf
		;EndIf
	Next
	
	;Smokes
	For smoke.smoke = Each smoke
		smoke\alpha#=smoke\alpha#-(0.01*fpsfak#)
		If smoke\alpha#<0.0 Then
			FreeEntity smoke\h
			Delete smoke
		Else
			EntityAlpha smoke\h,smoke\alpha#
			TranslateEntity smoke\h,0,(0.2*fpsfak#),0
		EndIf
	Next
	
	;Sparks
	For spark.spark = Each spark
		spark\alpha#=spark\alpha#-(0.02*fpsfak#)
		If spark\alpha#<0.0 Then
			FreeEntity spark\ph
			Delete spark
		Else
			MoveEntity spark\ph,0,0,spark\speed#*fpsfak#
			TranslateEntity spark\ph,0,-(spark\speed#/2)*fpsfak#,0
			EntityAlpha spark\h,spark\alpha#
		EndIf
	Next
	
	
	;Cullen
	For obj.obj=Each obj
		If EntityInView(obj\h,cam) Then
			ShowEntity obj\h
		Else
			HideEntity obj\h
		EndIf
	Next
	
	
	;FPS
	If ms-fpsms>499 Then
		fpsms=ms
		fps=fpsf*2
		fpsf=0
		fpsfak#=50.0/Float(fps)
		If fpsfak#>10.0 Then fpsfak#=10.0
	EndIf
		
	MoveMouse op_scrx/2,op_scry/2
	RenderWorld
	
	;Anzeigen
	DrawImage gfx_fire, 5, op_scry-69, fire
	DrawImage gfx_object, op_scrx-69, op_scry-69, selo
	DrawImage gfx_ch,op_scrx/2,op_scry/2
	Select fwcol
		Case 0 Color 255,0,0
		Case 1 Color 0,255,0
		Case 2 Color 0,0,255
		Case 3 Color 255,255,0
		Case 4 Color 0,255,255
		Case 5 Color 255,0,255
	End Select
	Oval op_scrx-39, op_scry-39,24,24,1
	Color 255,150,0
	
	;Debug
	If debug Then
		Text 0,0,"FPS: "+fps
		Text 150,0,"Trisrenderd: "+TrisRendered()
	EndIf
	
	;Help
	If help Then
		x=0
		x=x+20:Text 0,x,"Hilfe:"
		x=x+20:Text 0,x,"[W,A,S,D] = Bewegen"
		x=x+20:Text 0,x,"[Linke Maustaste] = Objekt setzen"
		x=x+20:Text 0,x,"[Rechte Maustaste] = Objekt anznden"
		x=x+20:Text 0,x,"[Mausrad / E] = Objekt wechseln"
		x=x+20:Text 0,x,"[1-6] = Farbe whlen"
		x=x+20:Text 0,x,"[7] = zufllige Farbe"
		x=x+20:Text 0,x,"[F] = Feuer an/aus (Objekte beim setzen anznden)"
		x=x+20:Text 0,x,"[R] = Zufllig 3 Raketen verteilen"
		x=x+20:Text 0,x,"[F1] = Hilfe an/aus"
		x=x+20:Text 0,x,"[F12] = Debug Infos an/aus"
		x=x+20:Text 0,x,"[Leertaste] = Alles anznden"
	EndIf
	
	
	
	Flip
	fpsf=fpsf+1
	
Wend